=== debian/changelog ===
rhash (1.3.1-1) unstable; urgency=low

  * New upstream release version 1.3.1
   - bump Standards-Version to 3.9.5

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Wed, 08 Jan 2014 23:47:28 +0700

rhash (1.3.0-3) unstable; urgency=low

  * Fixed 'Value too large...' error (Closes: #727012)

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Sun, 24 Nov 2013 20:19:26 +0700

rhash (1.3.0-2) unstable; urgency=low

  * Fixed sha3 on big-endian processors

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Sun, 22 Sep 2013 00:51:37 +0700

rhash (1.3.0-1) unstable; urgency=low

  * New upstream release version 1.3.0
   - switched the package back to unstable

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Mon, 16 Sep 2013 19:48:55 +0700

rhash (1.2.10-1) experimental; urgency=low

  * New upstream release version 1.2.10
   - switched to Debhelper 9 and Standards-Version 3.9.4
   - moved language bindings to separate rhash-bindings package

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Tue, 25 Dec 2012 01:55:52 +0700
