=== debian/watch ===
version=3
http://sf.net/rhash/rhash-([\d\.]+)-src\.tar\.gz
