## rhash 1.3.3

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # compile with debug info: make CFLAGS=-g
 # compile for pentiumpro: make CFLAGS="-O2 -DNDEBUG -march=i586 -mcpu=pentiumpro -fomit-frame-pointer"
 # create rpm with statically linked program: make rpm ADDLDFLAGS="-static -s -Wl,--gc-sections"
-VERSION = 1.3.1
+VERSION = 1.3.3
 PREFIX  = /usr/local
 CC      = gcc
 # using OPTFLAGS/OPTLDFLAGS for compatibilty with old scripts using this makefile
@@ -18,7 +18,7 @@
 LDLIBRHASH = -Llibrhash -lrhash
 ALLLDFLAGS = $(LDLIBRHASH) $(LDFLAGS) $(ADDLDFLAGS)
 SHAREDLIB  = librhash/librhash.so.0
-SHRDLFLAGS = $(SHAREDLIB) $(LDFLAGS) $(ADDLDFLAGS)
+SHRDLFLAGS = $(LDFLAGS) $(ADDLDFLAGS)
 HEADERS = calc_sums.h hash_print.h common_func.h hash_update.h file_mask.h file_set.h find_file.h hash_check.h output.h parse_cmdline.h rhash_main.h win_utils.h version.h
 SOURCES = calc_sums.c hash_print.c common_func.c hash_update.c file_mask.c file_set.c find_file.c hash_check.c output.c parse_cmdline.c rhash_main.c win_utils.c
 OBJECTS = calc_sums.o hash_print.o common_func.o hash_update.o file_mask.o file_set.o find_file.o hash_check.o output.o parse_cmdline.o rhash_main.o win_utils.o
@@ -29,14 +29,16 @@
 SYMLINKS = sfv-hash tiger-hash tth-hash whirlpool-hash has160-hash gost-hash ed2k-link magnet-link
 SPECFILE = dist/rhash.spec
 LIN_DIST_FILES = Makefile ChangeLog INSTALL COPYING README \
-  $(SPECFILE) $(SPECFILE).in $(SOURCES) $(HEADERS) tests/test_rhash.sh \
+  $(SPECFILE) $(SPECFILE).in $(SOURCES) $(HEADERS) \
+  tests/test_rhash.sh tests/test1K.data \
   dist/rhash.1 dist/rhash.1.win.sed dist/rhash.1.html
 WIN_DIST_FILES = dist/MD5.bat dist/magnet.bat dist/rhashrc.sample
 WIN_SRC_FILES  = win32/dirent.h win32/stdint.h win32/unistd.h win32/platform-dependent.h \
   win32/vc-2010/rhash.vcxproj
 LIBRHASH_FILES  = librhash/algorithms.c librhash/algorithms.h \
-  librhash/byte_order.c librhash/byte_order.h librhash/rhash_timing.c librhash/rhash_timing.h \
-  librhash/plug_openssl.c librhash/plug_openssl.h librhash/rhash.c librhash/rhash.h \
+  librhash/byte_order.c librhash/byte_order.h librhash/plug_openssl.c librhash/plug_openssl.h \
+  librhash/rhash.c librhash/rhash.h librhash/rhash_torrent.c librhash/rhash_torrent.h \
+  librhash/rhash_timing.c librhash/rhash_timing.h \
   librhash/aich.c librhash/aich.h librhash/crc32.c librhash/crc32.h \
   librhash/ed2k.c librhash/ed2k.h librhash/edonr.c librhash/edonr.h \
   librhash/gost.c librhash/gost.h librhash/has160.c librhash/has160.h \
@@ -70,6 +72,7 @@
 
 install: all install-binary install-data install-symlinks
 install-shared: $(SHARED_TRG) install-shared-binary install-data install-symlinks
+install-data: install-man install-conf
 uninstall: uninstall-binary uninstall-data uninstall-symlinks
 
 # creating archives
@@ -87,23 +90,27 @@
 zip : $(ARCHIVE_ZIP)
 dgz:  check $(ARCHIVE_DEB_GZ)
 
-install-binary:
+mkdir-bin:
 	$(INSTALL) -d $(DESTDIR)$(BINDIR)
+
+install-binary: mkdir-bin
 	$(INSTALL_PROGRAM) $(TARGET) $(DESTDIR)$(BINDIR)
 
 # install dynamically linked binary
-install-shared-binary:
-	$(INSTALL) -d $(DESTDIR)$(BINDIR)
+install-shared-binary: mkdir-bin
 	$(INSTALL_PROGRAM) $(SHARED_TRG) $(DESTDIR)$(BINDIR)/rhash
 
-install-data:
-	$(INSTALL) -d $(DESTDIR)$(MANDIR)/man1 $(DESTDIR)/etc
+install-man:
+	$(INSTALL) -d $(DESTDIR)$(MANDIR)/man1
 	$(INSTALL_DATA) dist/rhash.1 $(DESTDIR)$(MANDIR)/man1/rhash.1
-	sed -e 's/\x0D//g' dist/rhashrc.sample > rhashrc && $(INSTALL_DATA) rhashrc $(DESTDIR)/etc/rhashrc
-	rm -f rhashrc
-
-# dependencies should be properly set, otherwise 'make -j<n>' can run install targets in parallel
-install-symlinks:
+
+install-conf:
+	$(INSTALL) -d $(DESTDIR)/etc
+	sed -e 's/\x0D//g' dist/rhashrc.sample > rc.tmp && $(INSTALL_DATA) rc.tmp $(DESTDIR)/etc/rhashrc
+	rm -f rc.tmp
+
+# dependencies should be properly set, otherwise 'make -j<n>' can fail
+install-symlinks: mkdir-bin install-man
 	for f in $(SYMLINKS); do ln -fs rhash $(DESTDIR)$(BINDIR)/$$f; done
 	cd $(DESTDIR)$(MANDIR)/man1 && for f in $(SYMLINKS); do ln -fs rhash.1* $$f.1; done
 
@@ -139,11 +146,11 @@
 
 test: test-static
 test-static: $(TARGET)
-	chmod +x tests/test_$(PROGNAME).sh
-	tests/test_$(PROGNAME).sh
+	chmod +x tests/test_rhash.sh
+	tests/test_rhash.sh
 
 test-shared: $(SHARED_TRG) test-shared-lib
-	chmod +x tests/test_$(PROGNAME).sh
+	chmod +x tests/test_rhash.sh
 	LD_LIBRARY_PATH=../librhash:$(LD_LIBRARY_PATH) tests/test_rhash.sh ./$(SHARED_TRG)
 
 version.h: Makefile
@@ -161,64 +168,59 @@
 	$(CC) $(OBJECTS) -o $@ $(ALLLDFLAGS)
 
 $(SHARED_TRG): $(OBJECTS) $(SHAREDLIB)
-	$(CC) $(OBJECTS) -o $(SHARED_TRG) $(SHRDLFLAGS)
+	$(CC) $(OBJECTS) $(SHRDLFLAGS) -o $(SHARED_TRG) $(SHAREDLIB)
 
 # NOTE: dependences were generated by 'gcc -Ilibrhash -MM *.c'
 # we are using plain old makefile style to support BSD make
-calc_sums.o: calc_sums.c common_func.h librhash/util.h librhash/hex.h \
- librhash/rhash.h librhash/rhash_timing.h parse_cmdline.h rhash_main.h \
- file_set.h calc_sums.h hash_check.h hash_print.h output.h win_utils.h \
+calc_sums.o: calc_sums.c common_func.h librhash/rhash.h \
+ librhash/rhash_torrent.h parse_cmdline.h rhash_main.h hash_print.h \
+ output.h win_utils.h calc_sums.h hash_check.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+common_func.o: common_func.c common_func.h win_utils.h parse_cmdline.h \
  version.h
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
-common_func.o: common_func.c common_func.h librhash/util.h librhash/hex.h \
- win_utils.h parse_cmdline.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-hash_print.o: hash_print.c common_func.h librhash/util.h librhash/hex.h \
- librhash/byte_order.h calc_sums.h librhash/rhash.h hash_check.h \
- parse_cmdline.h hash_print.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-hash_update.o: hash_update.c common_func.h librhash/util.h \
- librhash/rhash_timing.h win_utils.h parse_cmdline.h output.h rhash_main.h \
- file_set.h calc_sums.h librhash/rhash.h hash_check.h file_mask.h \
- hash_update.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-file_mask.o: file_mask.c common_func.h librhash/util.h file_mask.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-file_set.o: file_set.c librhash/hex.h librhash/crc32.h common_func.h \
- librhash/util.h hash_print.h parse_cmdline.h rhash_main.h output.h \
- file_set.h calc_sums.h librhash/rhash.h hash_check.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-find_file.o: find_file.c common_func.h librhash/util.h win_utils.h \
- find_file.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-hash_check.o: hash_check.c librhash/hex.h librhash/byte_order.h \
- librhash/rhash.h output.h parse_cmdline.h hash_print.h hash_check.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-output.o: output.c common_func.h librhash/util.h librhash/rhash.h \
- calc_sums.h hash_check.h parse_cmdline.h rhash_main.h output.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-parse_cmdline.o: parse_cmdline.c common_func.h librhash/util.h \
- librhash/rhash.h librhash/plug_openssl.h win_utils.h file_mask.h \
- hash_print.h output.h rhash_main.h version.h parse_cmdline.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-rhash_main.o: rhash_main.c common_func.h librhash/util.h \
- librhash/rhash_timing.h win_utils.h find_file.h file_set.h calc_sums.h \
- librhash/rhash.h hash_check.h hash_update.h file_mask.h hash_print.h \
- parse_cmdline.h output.h version.h rhash_main.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-win_utils.o: win_utils.c common_func.h librhash/util.h parse_cmdline.h \
- rhash_main.h win_utils.h
+file_mask.o: file_mask.c common_func.h file_mask.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+file_set.o: file_set.c librhash/rhash.h common_func.h hash_print.h \
+ parse_cmdline.h rhash_main.h output.h file_set.h calc_sums.h \
+ hash_check.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+find_file.o: find_file.c common_func.h output.h win_utils.h find_file.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+hash_check.o: hash_check.c librhash/rhash.h output.h common_func.h \
+ parse_cmdline.h hash_print.h hash_check.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+hash_print.o: hash_print.c common_func.h librhash/rhash.h calc_sums.h \
+ hash_check.h parse_cmdline.h win_utils.h hash_print.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+hash_update.o: hash_update.c common_func.h win_utils.h parse_cmdline.h \
+ output.h rhash_main.h file_set.h calc_sums.h hash_check.h file_mask.h \
+ hash_print.h hash_update.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+output.o: output.c common_func.h librhash/rhash.h calc_sums.h \
+ hash_check.h parse_cmdline.h rhash_main.h win_utils.h output.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+parse_cmdline.o: parse_cmdline.c common_func.h librhash/rhash.h \
+ win_utils.h file_mask.h find_file.h hash_print.h output.h rhash_main.h \
+ parse_cmdline.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+rhash_main.o: rhash_main.c common_func.h librhash/rhash.h win_utils.h \
+ find_file.h calc_sums.h hash_check.h hash_update.h file_mask.h \
+ hash_print.h parse_cmdline.h output.h rhash_main.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+win_utils.o: win_utils.c common_func.h parse_cmdline.h rhash_main.h \
+ win_utils.h
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
 dist/rhash.1.win.html: dist/rhash.1 dist/rhash.1.win.sed
@@ -239,7 +241,7 @@
 
 permissions:
 	find . dist librhash po win32 win32/vc-2010 -maxdepth 1 -type f -exec chmod -x '{}' \;
-	chmod +x tests/test_$(PROGNAME).sh
+	chmod +x tests/test_rhash.sh
 
 clean-bindings:
 	+make -C bindings distclean
@@ -309,3 +311,16 @@
 	xgettext *.c -k_ -cTRANSLATORS -o po/rhash.pot \
 		--msgid-bugs-address='Aleksey <rhash.admin@gmail.com>' --package-name='RHash'
 	for f in po/*.po; do \
+		msgmerge -U $$f po/rhash.pot; \
+	done
+
+compile-gmo:
+	for f in po/*.po; do \
+		g=`basename $$f .po`; \
+		msgfmt $$f -o po/$$g.gmo; \
+	done
+
+install-gmo: compile-gmo
+	for f in po/*.gmo; do \
+		l=`basename $$f .gmo`; \
+		$(INSTALL) -d $(DESTDIR)$(LOCALEDIR)/$$l/LC_MESSAGES; \
