=== librhash/Makefile ===
--- 
+++ 
@@ -16,10 +16,12 @@
 ALLCFLAGS = $(LIBCFLAGS) $(PRGCFLAGS)
 LDRHASH    = -L. -lrhash
 LIBLDFLAGS = $(LDFLAGS) $(ADDLDFLAGS)
-HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_timing.h util.h aich.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h sha3.h ripemd-160.h gost.h has160.h snefru.h tiger.h              tth.h torrent.h whirlpool.h
-SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_timing.c util.c aich.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c sha3.c ripemd-160.c gost.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c whirlpool.c whirlpool_sbox.c
-OBJECTS = algorithms.o byte_order.o plug_openssl.o rhash.o rhash_timing.o util.o aich.o crc32.o ed2k.o edonr.o hex.o md4.o md5.o sha1.o sha256.o sha512.o sha3.o ripemd-160.o gost.o has160.o snefru.o tiger.o tiger_sbox.o tth.o torrent.o whirlpool.o whirlpool_sbox.o
-LIB_HEADERS = rhash.h rhash_timing.h
+HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_timing.h rhash_torrent.h util.h aich.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h sha3.h ripemd-160.h gost.h has160.h snefru.h tiger.h              tth.h torrent.h whirlpool.h
+SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_timing.c rhash_torrent.c util.c aich.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c sha3.c ripemd-160.c gost.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c whirlpool.c whirlpool_sbox.c
+OBJECTS = algorithms.o byte_order.o plug_openssl.o rhash.o rhash_timing.o rhash_torrent.o util.o aich.o crc32.o ed2k.o edonr.o hex.o md4.o md5.o sha1.o sha256.o sha512.o sha3.o ripemd-160.o gost.o has160.o snefru.o tiger.o tiger_sbox.o tth.o torrent.o whirlpool.o whirlpool_sbox.o
+LIB_HEADERS = rhash.h rhash_torrent.h
+LEGACY_LIB_HEADERS = rhash_timing.h
+SO_HEADERS = $(LIB_HEADERS) $(LEGACY_LIB_HEADERS)
 # installation directories and names
 DESTDIR =
 PREFIX  = /usr/local
@@ -119,6 +121,10 @@
  rhash_timing.h
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
+rhash_torrent.o: rhash_torrent.c algorithms.h rhash.h byte_order.h ustd.h \
+ config.h torrent.h sha1.h rhash_torrent.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
 ripemd-160.o: ripemd-160.c byte_order.h ustd.h config.h ripemd-160.h
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
@@ -138,7 +144,7 @@
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
 test_hashes.o: test_hashes.c byte_order.h ustd.h config.h rhash_timing.h \
- rhash.h test_hashes.h
+ rhash_torrent.h rhash.h test_hashes.h
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
 tiger.o: tiger.c byte_order.h ustd.h config.h tiger.h
@@ -176,7 +182,7 @@
 
 # shared and static libraries
 $(SONAME): $(SOURCES)
-	sed -n '1s/.*/{ global:/p; s/^RHASH_API.* \([a-z0-9_]\+\)(.*/  \1;/p; $$s/.*/local: *; };/p' $(LIB_HEADERS) > exports.sym
+	sed -n '1s/.*/{ global:/p; s/^RHASH_API.* \([a-z0-9_]\+\)(.*/  \1;/p; $$s/.*/local: *; };/p' $(SO_HEADERS) > exports.sym
 	$(CC) -fpic $(ALLCFLAGS) -shared $(SOURCES) -Wl,--version-script,exports.sym,-soname,$(SONAME) $(LIBLDFLAGS) -o $@
 	ln -s $(SONAME) $(SOLINK)
 # use 'nm -Cg --defined-only $@' to view exported symbols
