=== debian/changelog ===
rhash (1.3.3-1) unstable; urgency=low

  * New upstream release version 1.3.3
  * librhash now exports new torrent interface

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Tue, 05 Aug 2014 02:12:06 +0700

rhash (1.3.2-2) unstable; urgency=low

  * fix symlinks installation when building the package

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Fri, 04 Jul 2014 02:53:00 +0700

rhash (1.3.2-1) unstable; urgency=low

  *  New upstream release version 1.3.2
   - fixed infinite loop while working with symlinks (Closes: #750842)
   - fixed the hardening-no-relro lintian warning

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Wed, 02 Jul 2014 01:41:59 +0700
