=== debian/rules ===
--- 
+++ 
@@ -25,8 +25,8 @@
 
 # by default compile RHash with openssl runtime linking
 ifeq (,$(findstring nossl,$(DEB_BUILD_OPTIONS)))
+ifneq (,$(findstring ssldynamic,$(DEB_BUILD_OPTIONS)))
 	LIBCFLAGS += -DUSE_OPENSSL
-ifneq (,$(findstring ssldynamic,$(DEB_BUILD_OPTIONS)))
 	LIBLDFLAGS += -lcrypto
 else
 	LIBCFLAGS  += -DOPENSSL_RUNTIME -rdynamic
@@ -45,10 +45,16 @@
 
 override_dh_auto_build:
 override_dh_auto_test:
-	$(MAKE) test-static-lib CFLAGS="$(CFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)"
-	$(MAKE) test-shared CFLAGS="$(CFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)" LD_LIBRARY_PATH="$(LD_LIB)"
+	# note: static and shared libraries will be built if not exist yet
+	$(MAKE) test-static-lib CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
+		LIBCFLAGS="$(LIBCFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)"
+	$(MAKE) test-shared CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
+		LIBCFLAGS="$(LIBCFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)" LD_LIBRARY_PATH="$(LD_LIB)"
 
 override_dh_auto_install:
+	# v1.3.2: quick fix for fail on parallel build
+	install -d $(CURDIR)/debian/rhash/usr/bin
+	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/rhash INSTALL_PROGRAM="$(INSTALL_PROGRAM)" install-data
 	# Install the program and its translation strings
 	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/rhash INSTALL_PROGRAM="$(INSTALL_PROGRAM)" install-shared install-gmo
 	# Install static library
